Formal Language Theory: Integrating Experimentation with Proof
=============================================================================

This directory contains the LaTeX source for the book.  The root
file is `book.tex`.

Run

```
  latexmk -pdfps book.tex
```

to generate the PDF version of the book: book.pdf.  A copy of
[`latexmk`](https://ctan.org/pkg/latexmk?lang=en) is in this
directory.

Modifying the Book
-----------------------------------------------------------------------------

The `BASE.eepic` files were generated using
[`xfig`](http://mcj.sourceforge.net) from the `BASE.fig` files.  Xfig
should be started up with the

```
  -latexfonts -specialtext -exportLanguage eepic
```

options.

The `chap-N.M-forlanL.tex` Forlan transcripts were generated from the
`chap-N.M-forlanL` files, using the program
[`smlnjtrans`](https://github.com/alleystoughton/SMLNJtrans).

This process was automated by the `chap-N.M-transcripts` shell
scripts.  To run these scripts, you must have both `smlnjtrans` and
`forlan` on your search path.  The script
[`book-transcripts`](book-transcripts) runs all of the transcripts.

The script [`cleanup`](cleanup) can be used to delete all of the files
generated by `latex`, `bibtex`, etc.

Run [`make-and-install-book`](make-and-install-book) to generate the
book and install in the `HTML` directory.
